# encoding: utf-8
"""
play.py

particle-expelling algorithm 
"""

import warnings
import random
import os
import sys
import numpy
import matplotlib.pyplot as plt

import shapely

# ================================================================================
# main
# ================================================================================

class Layout():
    def __init__(self):
        self.boundaries = []

    def _test_coords(self, coords):
        coord_len = np.array( [len(xy) for xy in coords] )
        if any( np.diff(coord_len) ):
            raise ValueError('Inconsistent coordinate dimensions')
        if coord_len[0] == 1:
            raise ValueError('Scalar detected. Points should be 2D or 3D')
        if coord_len[0] > 3:
            raise ValueError('Data dimension too high. Points should be 2D or 3D')
        if len(coords) < 2:
            raise ValueError('Need at least two data points')

    def add_line(self, coords):
        """
        coords: x1, y1, x2, y2
        """
        if len(coords) != 4:
            raise ValueError('Input format: [x1, y1, x2, y2] (or tuple)')
        if any( not np.isscalar(xy) for xy in coords ): # exist not scalar
            raise ValueError('Each element of the coordinates should be scalar')

        x1, y1, x2, y2 = coords
        ls = LineString( ((x1,y1),(x2,y2)) )
        self.boundaries.append( ls )

    def add_poly(self, coords):
        """
        not done
        """
        pass

# end of CLASS Boundary

class Platform():
    def __init__(self):
        self.side_len = 100.0
        self.layout = []
    def add_layout(self, boundaries):
        self.layout += boundaries
# end of CLASS Platform

